unit iado;

interface

uses
    SysUtils, ActiveX, ComObj, Variants;

//-----------------------------------------------------------------------------
type
    //  ڑEؒfNX
    TAdoxJetBase = class
    private
        FOpened: Boolean;
    protected
        FCNN: OleVariant;
        FCAT: OleVariant;
    public
        constructor Create();
        destructor Destroy(); override;
        procedure OpenConnection(const Path, Pass: string);
        procedure CloseConnection();
        function this(): TAdoxJetBase;
        property Opened: Boolean read FOpened;
        property CNN: OleVariant read FCNN; 
        property CAT: OleVariant read FCAT; 
    end;
(*
    //  S(eXg)
    TAdoxJetTest = class(TAdoxJetBase)
    public
        FStrings: TStrings;
        procedure EnumProperty(PROP: OleVariant);
        procedure EnumProperties(Obj: OleVariant);

        procedure EnumTableProperty(table: OleVariant);
        procedure EnumTableColumnProperty(column: OleVariant);
        procedure EnumTableColumns(table: OleVariant);

        procedure EnumKeyProperty(key: OleVariant);
        procedure EnumKeyColumnProperty(column: OleVariant);
        procedure EnumKeyColumns(key: OleVariant);
        procedure EnumKeys(table: OleVariant);

        procedure EnumIndexProperty(idx: OleVariant);
        procedure EnumIndexColumnProperty(column: OleVariant);
        procedure EnumIndexColumns(idx: OleVariant);
        procedure EnumIndexs(table: OleVariant);

        procedure EnumProperty4CNN(Strings: TStrings);
        procedure EnumTables(Strings: TStrings);
    end;
*)

implementation

uses
    iadoconst;

//  ###########################################################################
//  TAdoxJetBase
//  ###########################################################################

//-----------------------------------------------------------------------------
//  RXgN^
constructor TAdoxJetBase.Create();
begin
    inherited;
    FOpened := false;
    FCNN := Unassigned;
    FCAT := Unassigned;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TAdoxJetBase.Destroy();
begin
    CloseConnection();
    inherited;
end;

//-----------------------------------------------------------------------------
//  gԂ
function TAdoxJetBase.this(): TAdoxJetBase;
begin
    Result := Self;
end;

//-----------------------------------------------------------------------------
//  ڑ쐬
function JetOleDbConnectionString(const Path, User, Pass: string): string;
const
    PARTS: array[0..2] of string
    = ('Data Source="%s";', 'User ID="%s";', 'Jet OLEDB:Database Password="%s";');
begin
    Result := 'Provider=Microsoft.Jet.OLEDB.4.0;';
    Result := Format('%s' + PARTS[0], [Result, Path]);
    if (User <> '') then Result := Format('%s' + PARTS[1], [Result, User]);
    if (Pass <> '') then Result := Format('%s' + PARTS[2], [Result, Pass]);
end;

//-----------------------------------------------------------------------------
//  ڑ
procedure TAdoxJetBase.OpenConnection(const Path, Pass: string);
begin
    try
        FCAT := CreateOleObject('ADOX.Catalog');
        FCAT.ActiveConnection := JetOleDbConnectionString(Path, '', Pass);
        FCNN := FCAT.ActiveConnection;
        FOpened := true;
    except
        raise;
    end;
end;

//-----------------------------------------------------------------------------
//  ؒf
procedure TAdoxJetBase.CloseConnection();
begin
    if FOpened then
    begin
        FCNN.Close;
        FCNN := UnAssigned;
        FCAT := UnAssigned;
        FOpened := false;
    end;
end;

(*
//  ###########################################################################
//  TAdoxJet
//  ###########################################################################

//-----------------------------------------------------------------------------
//  vpeB
procedure TAdoxJetTest.EnumProperty(PROP: OleVariant);
begin
    FStrings.Add(
        Format('%-40s...%s',[Prop.Name, Prop.Value])
    );
end;

//-----------------------------------------------------------------------------
//  vpeBB
procedure TAdoxJetTest.EnumProperties(Obj: OleVariant);
var
    i: integer;
    PROP: OleVariant;
begin
    for i := 0 to Obj.Properties.Count - 1 do
    begin
        PROP := Obj.Properties.Item[i];
        EnumProperty(PROP);
    end;
end;

//  Table Object 

//-----------------------------------------------------------------------------
//  TableIuWFNgpvpeB
procedure TAdoxJetTest.EnumTableProperty(table: OleVariant);
var
    s: string;
begin
    s := Format('\ %s', [table.Name]);
    FStrings.Add(s);
    s := Format('\ %s', [table.type]);
    FStrings.Add(s);
    s := Format('쐬 %s', [VarToStr(table.DateCreated)]);
    FStrings.Add(s);
    s := Format('XV %s', [VarToStr(table.DateModified)]);
    FStrings.Add(s);
end;

//-----------------------------------------------------------------------------
//  TableIuWFNgpColumnIuWFNgpvpeB
procedure TAdoxJetTest.EnumTableColumnProperty(column: OleVariant);
var
    s: string;
begin
    s := Format('񖼏     %s', [column.Name]);
    FStrings.Add(s);
    s := Format('^         %s', [DataTypeEnum2Str(column.Type)]);
    FStrings.Add(s);
    s := Format('       %s', [ColumnAttributesEnum2Str(column.Attributes)]);
    FStrings.Add(s);
    s := Format('oCg   %s', [column.DefinedSize]);
    FStrings.Add(s);
    s := Format('l^ %s', [column.NumericScale]);
    FStrings.Add(s);
    s := Format('x       %s', [column.Precision]);
    FStrings.Add(s);
end;

//-----------------------------------------------------------------------------
//  TableIuWFNgpColumnIuWFNg
procedure TAdoxJetTest.EnumTableColumns(table: OleVariant);
var
    i: integer;
    CLM: OleVariant;
begin
    if FOpened then
    begin
        for i := 0 to table.Columns.Count - 1 do
        begin
            try
                CLM := table.Columns.Item[i];
                FStrings.Add(StringOfChar('*', 20));
                EnumTableColumnProperty(CLM);
                EnumProperties(CLM);
            except
                on E:Exception do FStrings.Add(E.Message);
            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  TableIuWFNg
procedure TAdoxJetTest.EnumTables(Strings: TStrings);
var
    i: integer;
    TBL: OleVariant;
begin
    if FOpened then
    begin
        FStrings := Strings;
        for i := 0 to CAT.Tables.Count - 1 do
        begin
            TBL := CAT.Tables.Item[i];
            FStrings.Add(StringOfChar('=', 50));
            EnumTableProperty(TBL);
            EnumProperties(TBL);
            EnumTableColumns(TBL);
            EnumKeys(TBL);
            EnumIndexs(TBL);
        end;
    end;
end;

//  Key Object 

//-----------------------------------------------------------------------------
//  KeyIuWFNgpvpeB
procedure TAdoxJetTest.EnumKeyProperty(key: OleVariant);
var
    s: string;
begin
    s := Format('L[   %s', [key.Name]);
    FStrings.Add(s);
    s := Format('L[   %s', [S_KeyTypeEnum[Integer(key.type)]]);
    FStrings.Add(s);
    s := Format('֘A\     %s', [key.RelatedTable]);
    FStrings.Add(s);
    s := Format('폜[ %s', [S_RuleEnum[Integer(key.DeleteRule)]]);
    FStrings.Add(s);
    s := Format('XV[ %s', [S_RuleEnum[Integer(key.UpdateRule)]]);
    FStrings.Add(s);
end;

//-----------------------------------------------------------------------------
//  KeyIuWFNgpColumnIuWFNgpvpeB
procedure TAdoxJetTest.EnumKeyColumnProperty(column: OleVariant);
var
    s: string;
begin
    s := Format('񖼏     %s', [column.Name]);
    FStrings.Add(s);
    s := Format('֘A񖼏 %s', [column.RelatedColumn]);
    FStrings.Add(s);
end;

//-----------------------------------------------------------------------------
//  KeyIuWFNgpColumnIuWFNg
procedure TAdoxJetTest.EnumKeyColumns(key: OleVariant);
var
    i: integer;
    CLM: OleVariant;
begin
    if FOpened then
    begin
        for i := 0 to key.Columns.Count - 1 do
        begin
            try
                CLM := key.Columns.Item[i];
                FStrings.Add(StringOfChar('*', 20));
                EnumKeyColumnProperty(CLM);
            except
                on E:Exception do FStrings.Add(E.Message);
            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  KeyIuWFNg
procedure TAdoxJetTest.EnumKeys(table: OleVariant);
var
    i: integer;
    KEY: OleVariant;
begin
    if FOpened then
    begin
        for i := 0 to table.Keys.Count - 1 do
        begin
            KEY := table.Keys.Item[i];
            FStrings.Add(StringOfChar('-', 20));
            EnumKeyColumns(KEY);
            EnumKeyProperty(KEY);
        end;
    end;
end;

//  Index Object 

//-----------------------------------------------------------------------------
//  IndexIuWFNgpvpeB
procedure TAdoxJetTest.EnumIndexProperty(idx: OleVariant);
var
    s: string;
begin
    s := Format('CfbNX %s', [idx.Name]);
    FStrings.Add(s);
    if (idx.Unique) then s := 'must be unique' else s := 'must not be unique';
    FStrings.Add(s);
    if (idx.PrimaryKey) then s := 'is the primary key' else s := 'is not the primary key';
    FStrings.Add(s);
    s := Format('IndexNulls   %s', [S_AllowNullsEnum[Integer(idx.IndexNulls)]]);
    FStrings.Add(s);
    if (idx.Clustered) then s := 'is clustered' else s := 'is not clustered';
    FStrings.Add(s);
end;

//-----------------------------------------------------------------------------
//  IndexIuWFNgpColumnIuWFNgpvpeB
procedure TAdoxJetTest.EnumIndexColumnProperty(column: OleVariant);
var
    s: string;
begin
    s := Format('column name   %s', [column.Name]);
    FStrings.Add(s);
//    s := Format('SortOrder     %s', [SortOrderEnumStr[TSortOrderEnum(column.SortOrder)]]);
//    FStrings.Add(s);
end;

//-----------------------------------------------------------------------------
//  IndexIuWFNgpColumnIuWFNg
procedure TAdoxJetTest.EnumIndexColumns(idx: OleVariant);
var
    i: integer;
    CLM: OleVariant;
begin
    if FOpened then
    begin
        for i := 0 to idx.Columns.Count - 1 do
        begin
            try
                CLM := idx.Columns.Item[i];
                FStrings.Add(StringOfChar('*', 20));
                EnumIndexColumnProperty(CLM);
            except
                on E:Exception do FStrings.Add(E.Message);
            end;
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  IndexIuWFNg
procedure TAdoxJetTest.EnumIndexs(table: OleVariant);
var
    i: integer;
    IDX: OleVariant;
begin
    if FOpened then
    begin
        for i := 0 to table.Indexes.Count - 1 do
        begin
            IDX := table.Indexes.Item[i];
            FStrings.Add(StringOfChar('+', 20));
            EnumIndexColumnProperty(IDX);
            EnumIndexColumns(IDX);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ڑIuWFNg̃vpeB
procedure TAdoxJetTest.EnumProperty4CNN(Strings: TStrings);
begin
    if FOpened then
    begin
        FStrings := Strings;
        EnumProperties(CNN);
    end;
end;

*)

//-----------------------------------------------------------------------------
initialization
    CoInitialize(nil);
finalization
    CoUninitialize();
end.

